require "lib"
require "freehand_lib"

name = "Freehand Arrow"
key="option-shift-a"
menu_position = 302
custom_pen = true
submenu = "Freehand"
radius = 3


parameters = {"double_sided", "tip_width", "tip_length"}
double_sided = 0; double_sided_min = 0; double_sided_max = 1;
tip_width = 10; tip_width_min = 2; tip_width_max = 40;
tip_length = 15; tip_length_min = 2; tip_length_max = 40;

icon = "freehand_arrow_icon"
icon_position = 17

-- Custom drawing

curve = clone(freehand.curve_sampler)
curve:make_callbacks()

function pen_up()
	local c = curve:curve()
	if not c then return end
	
	local l = (tip_length - 1)/scale()
	c:shorten(l)
	local bp = c:path()
	set_line_width(bp, curve:line_width())
	add_stroke(bp)
	
	local d = normalize(c.p3 - c.p2)
	local e = normalize(c.p1 - c.p0)
	
	if double_sided == 1 then
		add_fill(lib.arrow_tip(c.p1, c.p0 - e*l, tip_width, tip_length))
	end
	
	add_fill(lib.arrow_tip(c.p2, c.p3 + d*l, tip_width, tip_length))
	
	curve:reset()
end

